/* 
 This file was generated by Dashcode and is covered by the 
 license.txt included in the project.  You may edit this file, 
 however it is recommended to first turn off the Dashcode 
 code generator otherwise the changes will be lost.
 */

function CreateStackLayout(elementOrID, spec)
{
    var containerElement = elementOrID;
    if (elementOrID.nodeType != Node.ELEMENT_NODE) {
        containerElement = document.getElementById(elementOrID);
    }
	if (!containerElement.loaded) {
		containerElement.loaded = true;
		containerElement.object = new StackLayout(containerElement, spec);
		
		return containerElement.object;
	}
}

function StackLayout(containerElement, spec)
{
    this.element = containerElement;
    
    var subviewsTransitions = spec.subviewsTransitions || [];
    
    this._views = [];
    this._currentView = null;
    this._viewsOldOpacity = [];
    var kids = containerElement.childNodes;
    this._inDesign = window.dashcode && window.dashcode.inDesign;
    var firstElementDone = false;
    for (var i=0; i<kids.length; i++) {
        if (kids[i].nodeType == Node.ELEMENT_NODE) {
            var view = kids[i];
            this._views[this._views.length] = view;
            // Doing this only during runtime since we don't want any of the settings to end up in the files during design time. Also, design time view swapping is done differently.
            if (!this._inDesign) {
                view.style.display = (firstElementDone) ? 'none' : 'block';
                // Remember the previous inline opacity because we make use of it for dissolve/fade transitions
                this._viewsOldOpacity[this._viewsOldOpacity.length] = view.style.opacity;
                view.style.opacity = (firstElementDone) ? 0 : 1;
                firstElementDone = true;
                
                // The StackLayout is most likely to have transitions. Prepare the subview to have layers by using an identity matrix. This will improve performance.
                view.style.webkitTransform = 'translate(0px, 0px)';
            }
        }
    }
    
    if (this._views.length > 0) {
        this._viewsTransition = [];
        this.setCurrentView(this._views[0]);
        
        if (this._views.length == subviewsTransitions.length) {
            for (var i=0; i<this._views.length; i++) {
                this._viewsTransition[i] = CreateTransitionWithProperties(subviewsTransitions[i]);
            }
        }
    }
}

StackLayout.prototype.getAllViews = function()
{
    return this._views;
}

StackLayout.prototype.getCurrentView = function()
{
    return this._currentView;
}

StackLayout.prototype.setCurrentView = function(newView, isReverse)
{
    // Look up by id if necessary
    newView = this._getView(newView);
    var oldView = this.getCurrentView();
	
    if (!newView || (oldView == newView)) {
        return;
    }
    
    // Make sure the view is ours
    if (!newView.parentNode == this.element) {
        return;
    }
    
    var transition = this._viewsTransition[this._views.indexOf(newView)];
    if (!transition) transition = new Transition(Transition.NONE_TYPE);
    
    if (oldView) {
        if (isReverse) {
            transition = this._viewsTransition[this._views.indexOf(oldView)];
        }
    }
    
    this._setCurrentViewPrimitive(newView, oldView, transition, isReverse);
}

StackLayout.prototype.setCurrentViewWithTransition = function(newView, transition, isReverse)
{
    // Look up by id if necessary
    newView = this._getView(newView);
    if (!newView) {
        return;
    }
    
    // Make sure the view is ours
    if (!newView.parentNode == this.element) {
        return;
    }
    var oldView = this.getCurrentView();
    
    this._setCurrentViewPrimitive(newView, oldView, transition, isReverse);
}

StackLayout.prototype.getTransitionForView = function(view)
{
    // Look up by id if necessary
    view = this._getView(view);
    return this._viewsTransition[this._views.indexOf(view)];
}

StackLayout.prototype._getView = function(view)
{
    if (view) {
        if (view.nodeType == Node.ELEMENT_NODE) {
            // Already an element
            return view;
        }
        if (view.element) {
            // It's a part object
            return view.element;
        }
        // Try it as an id
        return document.getElementById(view);
    }
    return null;
}

StackLayout.prototype._setCurrentViewPrimitive = function(newView, oldView, transition, isReverse)
{
    // newView must be the element now and all error checking has been done.
    
    // View swapping in design time is done in application. Also, we want to be very careful about performing transition during design time because the attributes that get added during the transition into the DOM will get persisted into the HTML during regeneration.
    if (!this._inDesign) {
        if (transition) {
            this._restoreOldOpacity(oldView);
            this._restoreOldOpacity(newView);
            transition.perform(newView, oldView, isReverse);
        }
        else {
            if (oldView) oldView.style.display = 'none';
            if (newView) {
                newView.style.display = 'block';
                this._restoreOldOpacity(newView);
            }
        }
    }
    
    this._currentView = newView;
}

// Restore previous inline opacity
StackLayout.prototype._restoreOldOpacity = function(view)
{
    if (view) {
        var oldOpacity = this._viewsOldOpacity[this._views.indexOf(view)];
        view.style.opacity = (oldOpacity !== undefined) ? oldOpacity : null;
    }
}
